#!/bin/sh
bspwm_dir="$HOME/.config/bspwm"
conkyrc_file="$bspwm_dir/conkyrc"
template_file="$bspwm_dir/conkyrc.template"
tmp_file="$bspwm_dir/conkyrc.tmp"

if [ -f "$conkyrc_file" ]; then
  rm "$conkyrc_file"
fi

gen_conky_conf(){
  if [ -f "$template_file" ]; then
    conky_width="220"
    this_script="$(echo "$0" | sed "s:$HOME/::")"
    echo "--- This file was generated by $this_script" > "$conkyrc_file"
    echo "--- Edit conkyrc.template to configure conky." >> "$conkyrc_file"

    cores_line="$(awk '/___CORES___/{print NR}' "$template_file")"
    if [ "$cores_line" ]; then
      # print everything before ___CORES___
      awk -v cl="$cores_line" 'NR<cl{print}' "$template_file" > "$tmp_file"
      cores="$(lscpu | awk '/^CPU\(s\):/ {print $2}')"
      if [ "$cores" -gt '1' ]; then
        n='0'
        p='%'
        while [ "$n" -lt "$cores" ] && [ "$n" -le '8' ]; do
          n="$((n+1))"
          printf '${offset 7}  \#%s${goto 46}${cpubar cpu%s 10,100} ${cpu cpu%s}%s\n' "$n" "$n" "$n" "$p"
        done >> "$tmp_file"
      fi
    fi

    bat_line="$(awk '/___BAT___/{print NR}' "$template_file")"
    if [ "$bat_line" ]; then
      # print everything between ___CORES___ and ___BAT___
      awk -v cl="$cores_line" -v bl="$bat_line" 'cl<NR && NR<bl{print}' "$template_file" >> "$tmp_file"
      for x in $(find /sys/class/power_supply/*B*); do
        bat="$(echo "$x" | awk -F '/' '{print $NF}')"
        conky_code_bat='${offset 7}PWR${goto 46}${battery_bar 10,100 batX}${goto 150}${battery_percent batX}%'
        printf "%s\\n" "$conky_code_bat" | sed "s/batX/$bat/g" >> "$tmp_file"
      done
    fi

    net_line="$(awk '/___NET___/{print NR}' "$template_file")"
    if [ "$net_line" ]; then
      # print everything between ___BAT___ and ___NET___
      awk -v nl="$net_line" -v bl="$bat_line" 'bl<NR && NR<nl{print}' "$template_file" >> "$tmp_file"
      default_gw="$(ip r | awk '$1 == "default" {print $5}')"
# wifi
      for nic in $(ip a | awk -F ': ' '/^[0-9]: w/ {print $2}'); do
        gateway="$(ip r | awk -v nic="$nic" '$5 == nic {print $3}')"
        conky_code_net='${if_existing /proc/net/route $nic}\
${voffset 10}${goto 0}_________________________________________________________\
${voffset 18}${goto 10}${font ___FONT___}$nic${font}${goto 100}${voffset -9}Wifi Level: ${wireless_link_qual $nic}/${wireless_link_qual_max $nic}${goto 100}${voffset 14}     Quality: ${wireless_link_qual_perc $nic}%\
${voffset 13}${goto 20}       SSID: ${goto 75}${wireless_essid $nic}\
${voffset 13}${goto 20}        MAC: ${goto 75}${wireless_ap $nic}${color}\
${voffset 13}${goto 20}___gateway___\
${voffset 13}${goto 20}  Local IP: ${goto 75}${addr $nic}\
${voffset 20}${goto 20}${voffset -4}Up: ${offset 6} ${upspeed $nic}/s ${goto 130}Total:${offset 10}${totalup $nic}\
${voffset 12}${goto 20}${upspeedgraph $nic 15,200}\
${voffset 24}${goto 20}Down : ${downspeed $nic}/s ${goto 130}Total:${offset 10}${totaldown $nic}\
${voffset 12}${goto 20}${downspeedgraph $nic 15,200}\
${voffset 24}${goto 20}Inbound: ${goto 85}${tcp_portmon 1 32767 count}\
${voffset 13}${goto 20}Outbound:${goto 85}${tcp_portmon 32768 61000 count}\
${voffset 13}${goto 20}Total:${goto 85}${tcp_portmon 1 65535 count}\
${endif}'
 #${color ___green___}
#${voffset 25}${goto 20}IN 1:${tcp_portmon 1 32767 lport 0}${tcp_portmon 1 32767 rhost 0} ${tcp_portmon 1 32767 rip 0} ${tcp_portmon 1 32767 rport 0}\
#${voffset 10}${goto 20}OUT 1:${tcp_portmon 32768 61000 lport 0} ${tcp_portmon 32768 61000 rhost 0} ${tcp_portmon 32768 61000 rip 0} ${tcp_portmon 32768 61000 rport 0}\

#external ip: ${execi 1800 curl ifconfig.me}
        if [ "$nic" = "$default_gw" ]; then
          conky_code_net="$(echo "$conky_code_net" | sed "s/___FONT___/Dejavu:pixelsize=18:style=Bold/g;s/___gateway___/Gateway: $gateway/")"
        else
          conky_code_net="$(echo "$conky_code_net" | sed "s/___FONT___/Dejavu:pixelsize=14/g;s/___gateway___/Gateway: \${goto 75}$gateway/")"
        fi

        printf "%s\\n" "$conky_code_net" | sed "s/\$nic/$nic/g;s/^/\${offset 7}/g" >> "$tmp_file"
        unset conky_code_net
      done

# ethernet
      for nic in $(ip a | awk -F ': ' '/^[0-9]: e/ {print $2}'); do
        gateway="$(ip r | awk -v nic="$nic" '$5 == nic {print $3}')"
        conky_code_net='${if_existing /proc/net/route $nic}\
${voffset 10}${goto 0}_________________________________________________________\
${voffset 18}${goto 10}${font ___FONT___}$nic${font}\
${voffset 13}${goto 20}___gateway___\
${voffset 13}${goto 20}  Local IP: ${goto 75}${addr $nic}\
${voffset 20}${goto 20}${voffset -4}Up: ${offset 6} ${upspeed $nic}/s ${goto 130}Total:${offset 10}${totalup $nic}\
${voffset 12}${goto 20}${upspeedgraph $nic 15,200}\
${voffset 24}${goto 20}Down : ${downspeed $nic}/s ${goto 130}Total:${offset 10}${totaldown $nic}\
${voffset 12}${goto 20}${downspeedgraph $nic 15,200}\
${voffset 24}${goto 20}Inbound: ${goto 85}${tcp_portmon 1 32767 count}\
${voffset 13}${goto 20}Outbound:${goto 85}${tcp_portmon 32768 61000 count}\
${voffset 13}${goto 20}Total:${goto 85}${tcp_portmon 1 65535 count}\
${endif}'
        if [ "$nic" = "$default_gw" ]; then
          conky_code_net="$(echo "$conky_code_net" | sed "s/___FONT___/Dejavu:pixelsize=18:style=Bold/g;s/___gateway___/Gateway: $gateway/")"
        else
          conky_code_net="$(echo "$conky_code_net" | sed "s/___FONT___/Dejavu:pixelsize=14/g;s/___gateway___/Gateway: \${goto 75}$gateway/")"
        fi

        printf "%s\\n" "$conky_code_net" | sed "s/\$nic/$nic/g;s/^/\${offset 7}/g" >> "$tmp_file"
        unset conky_code_net
      done
    # print everything after ___NET___
      awk -v nl="$net_line" 'NR>nl{print}' "$template_file" >> "$tmp_file"
    else
      cat "$template_file" >> "$tmp_file"
    fi

    sed "s/___width___/$conky_width/g;
         s/___green___/#00ff00/g; 
         s:i3/i3-list-workspaces.sh:bspwm/bspwm-list-workspaces.sh:g" \
        "$tmp_file" >> "$conkyrc_file"

    if [ -f "$tmp_file" ]; then
      rm "$tmp_file"
    fi
  fi
}

if [ "$template_file" -nt "$conkyrc_file" ] \
|| [ "$0" -nt "$conkyrc_file" ] \
|| [ ! -f "$conkyrc_file" ]; then
  gen_conky_conf
fi

conky_start() {
  if [ ! "$(pidof conky)" ]; then
    xprop -root -format CONKY_PID 8s -remove CONKY_PID
  fi

  conky_pid="$(xprop -root CONKY_PID | awk -F '"' '{print $2}')"

  if [ ! "$conky_pid" ]; then
    conky_pids_old="$(ps x -o "%p " -o "args=ARGS" \
                    | awk '/[ ]{4}?[0-9][0-9]{5}? conky/ && !/awk/ {print $1}')"

    conky -c "$conkyrc_file"

    conky_pids_new="$(ps x -o "%p " -o "args=ARGS" \
                    | awk '/[ ]{4}?[0-9][0-9]{5}? conky/ && !/awk/ {print $1}')"

    if [ "$(echo "$conky_pids_new" | wc -l)" -gt 1 ]; then
      for pid in $conky_pids_old; do
        conky_pids_new="$(echo "$conky_pids_new" | grep -v "$pid")"
      done
    fi

    conky_pid="$conky_pids_new"
    xprop -root -format CONKY_PID 8s -set CONKY_PID "$conky_pid"
  fi
}

conky_stop(){
  conky_pid="$(xprop -root CONKY_PID | awk -F '"' '{print $2}')"
  if [ "$conky_pid" ]; then
    kill "$conky_pid"
    xprop -root -format CONKY_PID 8s -remove CONKY_PID
  fi
}

conky_pid="$(xprop -root CONKY_PID | awk -F '"' '{print $2}')"
case "$1" in
  'on')  if [ ! "$conky_pid" ]; then 
           conky_start && bspc config left_padding 225
         fi;;
  'off') conky_stop && bspc config left_padding 0;;
  'start'|'restart') conky_stop; conky_start; bspc config left_padding 225;;
  'toggle'|*) if [ "$conky_pid" ]; then      
                conky_stop && bspc config left_padding 0
              else
                conky_start && bspc config left_padding 225
              fi;;
esac
exit 0
